/**
 *
 */
package com.wanji.indicators.cache;

import com.wanji.indicators.entity.BaseLaneInfo;
import com.wanji.indicators.service.BaseLaneInfoService;
import com.wanji.indicators.service.impl.BaseLaneInfoServiceImpl;
import com.wanji.indicators.util.PropertiesHelper;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;


@Component
public class BaseLaneCache {

    //车道基础信息
    private static Map<String, BaseLaneInfo> baseLaneInfoMap = new ConcurrentHashMap<>();

    private static BaseLaneCache instance;
    static  PropertiesHelper property = PropertiesHelper.getInstance();

    private BaseLaneCache() {
    }

    public static synchronized BaseLaneCache getInstance() {
        if (instance == null) {
            instance = new BaseLaneCache();
            loadData();
        }
        return instance;
    }

    private static void loadData() {
        ApplicationContext beanConf = new ClassPathXmlApplicationContext("spring-container.xml");
        BaseLaneInfoService baseLaneInfoService = beanConf.getBean(BaseLaneInfoServiceImpl.class);
        Map<String, BaseLaneInfo> map = baseLaneInfoService.findLaneInfo(property.getProperties().getProperty("full.area.cross.list"));
        baseLaneInfoMap.putAll(map);
    }

    public   Map<String, BaseLaneInfo> getBaseLaneInfoMap() {
        return baseLaneInfoMap;
    }

}
