package com.wanji.indicators.constant;

import java.util.Objects;

public enum CongestEnum {

    //******************************************************//
    NO_CONGEST("1","畅通"),
    LIGHT_CONGEST("2","轻微拥堵"),
    MODERATE_CONGEST("3","中度拥堵"),
    HEAVY_CONGEST("4","重度拥堵")
    ;
    //******************************************************//
    private String type;
    private String name;

    CongestEnum(String type, String name) {
        this.type = type;
        this.name = name;
    }

    public static String getName(String type){
        for(CongestEnum typeEnum: CongestEnum.values()){
            if(Objects.equals(typeEnum.type,type)){
                return typeEnum.name;
            }
        }
        return null;
    }

    public static String getType(CongestEnum type) {
        for(CongestEnum typeEnum: CongestEnum.values()) {
            if(Objects.equals(typeEnum,type)){
                return typeEnum.type;
            }
        }
        return null;
    }

    public String getType() {
        return type;
    }

    public String getName() {
        return name;
    }
}
