package com.wanji.indicators.event.cross.accident.funcnew;

import com.wanji.indicators.constant.Constant;
import com.wanji.indicators.model.ConfigModel;
import com.wanji.indicators.model.CongestionArea;
import com.wanji.indicators.model.event.accident.AccidentFrameModel;
import com.wanji.indicators.util.PtInPolyUtil;
import org.apache.commons.lang3.StringUtils;
import org.apache.flink.streaming.api.functions.co.CoFlatMapFunction;
import org.apache.flink.util.Collector;

import java.util.*;


public class AccidentCheckCongestionAreaCoFlatMap implements CoFlatMapFunction<AccidentFrameModel, HashMap<String, Map<String, CongestionArea>>, AccidentFrameModel> {

    private HashMap<String, Map<String, CongestionArea>> hashMap = new HashMap();

    @Override
    public void flatMap1(AccidentFrameModel accidentFrameModel, Collector<AccidentFrameModel> collector) throws Exception {
        List<AccidentFrameModel.CarTrack> trackList = accidentFrameModel.getTrackList();
        ConfigModel configModel = accidentFrameModel.getConfigModel();
        List<AccidentFrameModel.CarTrack> list = new ArrayList<>();
        Set<Integer> set = new HashSet<>();
        Map<String, CongestionArea> congestionAreaDoMap = hashMap.get(accidentFrameModel.getCrossId());
        if (congestionAreaDoMap != null) {
            Map<String, Integer> map = new HashMap<>();
            for (CongestionArea congestionAreaDo : congestionAreaDoMap.values()) {
                //存入各出口rid对应的车道数
                int laneNum = congestionAreaDo.getLaneNum();
                if (laneNum > 0) {
                    //存入各出口rid对应的车道数
                    map.put(congestionAreaDo.getRid(), laneNum);
                }
            }
            accidentFrameModel.setCongestionInfo(map);

            for (AccidentFrameModel.CarTrack carTrack : trackList) {
                String entryLane = carTrack.getRoadnet().getLaneId();
                if (carTrack.getRoadnet().getInCrossFlag() == Constant.CROSSING && carTrack.getSpeed() < configModel.getAbnormalParkCongestSpeed() && StringUtils.isNotBlank(entryLane)) {
                    for (CongestionArea congestionAreaDo : congestionAreaDoMap.values()) {
                        String ridIn = entryLane.substring(0, 23);
                        //判断是否属于该方向验证的入口rid数据
                        if (congestionAreaDo.getRidInArr().contains(ridIn)) {
                            PtInPolyUtil.Point point = new PtInPolyUtil.Point(carTrack.getLongitude(), carTrack.getLatitude());
                            boolean isIn = PtInPolyUtil.isPtInPoly(point, congestionAreaDo.getPoints());
                            if (isIn) {
                                if (set.add(carTrack.getId())) {
                                    carTrack.setCongestionOutRid(congestionAreaDo.getRid());
                                    list.add(carTrack);
                                }
                            }
                        }
                    }
                }
            }
            for (AccidentFrameModel.CarTrack carTrack : trackList) {
                if (!set.contains(carTrack.getId())) {
                    list.add(carTrack);
                }
            }
            accidentFrameModel.setTrackList(list);
        }
        collector.collect(accidentFrameModel);
    }

    @Override
    public void flatMap2(HashMap<String, Map<String, CongestionArea>> stringCongestionAreaDoHashMap, Collector<AccidentFrameModel> collector) throws Exception {
        this.hashMap = stringCongestionAreaDoHashMap;
    }

}
