package com.wanji.indicators.event.cross.conflictpoint.func;

import com.wanji.indicators.model.CarTrackModel;
import com.wanji.indicators.model.CrossFrameModel;
import com.wanji.indicators.model.FrameModel;
import org.apache.commons.lang3.StringUtils;
import org.apache.flink.streaming.api.functions.co.CoFlatMapFunction;
import org.apache.flink.util.Collector;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

public class ConflictWaitingAreaCoFlatMap implements CoFlatMapFunction<CrossFrameModel, HashMap<String, Integer>, CrossFrameModel> {

    private HashMap<String, Integer> map = new HashMap();

    @Override
    public void flatMap1(CrossFrameModel frameModel, Collector<CrossFrameModel> collector) throws Exception {
        List<CarTrackModel> resultList = new ArrayList<>();

        List<CarTrackModel> trackList = frameModel.getTrackList();
        for(CarTrackModel carTrack : trackList){
            String entryLane = carTrack.getRoadnet().getLaneId();
            if (StringUtils.isNotBlank(entryLane)) {
                //待转区车道距离
                Integer integer = map.get(entryLane);
                if (integer != null && integer > 0) {
                    if (carTrack.getWaitingTurnLaneDist() > (1.5 + integer * 1.0)) {
                        resultList.add(carTrack);
                    }
                } else {
                    resultList.add(carTrack);
                }
            }
        }
        frameModel.setTrackList(resultList);
        collector.collect(frameModel);
    }

    @Override
    public void flatMap2(HashMap<String, Integer> hashMap, Collector<CrossFrameModel> collector) throws Exception {
        this.map = hashMap;
    }
}
