package com.wanji.indicators.model.event.confilct;


import com.wanji.indicators.model.ConfigModel;
import lombok.Data;

import java.io.Serializable;
import java.util.List;
import java.util.Map;

@Data
public class EventCross implements Serializable {

    ConfigModel configModel = new ConfigModel();
    /**
     * 路口唯一id
     */
    private String crossId;
    /**
     * 路口车辆唯一id
     */
    private int trackId;
    /**
     * 经度
     */
    private double lng;
    /**
     * 纬度
     */
    private double lat;
    /**
     * 当前所在车道
     */
    private String matchLane;
    /**
     *
     */
    private String matchLaneName;
    /**
     * 路口入口车道
     */
    private String entryLane;
    /**
     * 当前所在rid
     */
    private String rid;
    /**
     * 速度
     */
    private double speed;
    /**
     * 转向角度
     */
    private double driveAngle;
    /**
     * 车牌
     */
    private String plateNumber;
    /**
     * 车辆类型
     */
    private int vehicleType;
    /**
     * 车牌类型
     */
    private int plateType;
    /**
     * 车牌颜色
     */
    private int plateColor;
    /**
     * 车身颜色
     */
    private int vehicleColor;
    /**
     * 车辆品牌
     */
    private String vehicleBrand;
    /**
     * 数据类型  行人机动车 / 2 / 3
     */
    private int objectType;
    /**
     * 是否在路口面 1 = 在路口面  0 = 不在路口面
     */
    private int crossing;
    /**
     * 车道上  车辆离停止线的距离 过了停止线 = -1
     */
    private double stopLineDist;
    /**
     * 路口面上  车辆离开停止线的距离
     */
    private double areaDist;
    /**
     * 事件时间
     */
    private long time;
    /**
     * 持续时间
     */
    private long duration;
    /**
     * 车道功能 1左转 2直行 3右转 4掉头
     */
    private String laneFunction;
    /**
     * 加速度
     */
    private double at;

    private long startTime;
    private long endTime;
    //记录当前车辆与其周围所有运动车辆的距离；
    private Map<Integer,Double> mark;
    private List<EventCross> list;
    private double distance;
    private double ratio;
    private double maxSpeed;
    /**
     * 信号灯态
     * @return
     */
    private String lampState;
    /**
     * 分类事件 的 类型代码
     */
    private int typeCode;
    /**
     * 累计的出口行车距离
     */
    private double areaDistOut;
    /**
     * 旅行时间
     */
    private double travelTime;
    /**
     * 车道位置字典（Lane location)
     */
    private String laneLocation;

    private int eventState;

    private String recoveryCross;//设备名称

    private String trackIdNear;

    //冲突临近对象
    private EventCross nearTrackObj;

    private int category;


}
