package com.wanji.indicators.source;

import com.wanji.indicators.model.event.WaitingAreaDo;
import com.wanji.indicators.util.DateUtil;
import org.apache.flink.streaming.api.functions.source.RichParallelSourceFunction;

import java.util.HashMap;
import java.util.List;

/**
 * @Author ke.han
 * @Date 2020/4/16 19:03
 **/
public class WaitLaneSource extends RichParallelSourceFunction<
        HashMap<String, Integer>> {

    public static void main(String[] args) {
        System.out.println(DateUtil.toDateTime(1697244174106L,"yyyy-MM-dd HH:mm:ss"));
    }

    private volatile boolean running = true;

    @Override
    public void run(SourceContext<HashMap<String, Integer>> out) {
        HashMap<String, Integer> outMap = new HashMap<>();
        if (running) {
            String sql = "SELECT * FROM cross_flink_settings";
            List<WaitingAreaDo> ridLaneNumDos = null;//new JdbcUtil().excuteQueryToList(WaitingAreaDo.class, sql);
            if (ridLaneNumDos != null && !ridLaneNumDos.isEmpty()) {
                outMap.clear();
                for (WaitingAreaDo data : ridLaneNumDos) {
                    String laneId = data.getLaneId();
                    Integer waitingArea = data.getWaitingArea();
                    outMap.put(laneId.trim(), waitingArea);
                }
            }
            if (outMap.size() > 0) {
                out.collect(outMap);
            }
//            Thread.sleep(1000*60);
        }
    }

    @Override
    public void cancel() {
        running = false;
    }
}
