package com.wanji.indicators.task.area.service.func;

import com.wanji.indicators.constant.Constant;
import com.wanji.indicators.constant.RoadClassMap;
import com.wanji.indicators.entity.BaseLaneInfo;
import com.wanji.indicators.model.CarTrackModel;
import com.wanji.indicators.model.CrossFrameModel;
import org.apache.flink.streaming.api.functions.co.CoFlatMapFunction;
import org.apache.flink.util.Collector;

import java.util.*;

public class RidFreeSpeedCoFlatMap implements CoFlatMapFunction<CarTrackModel,  Map<String, Map<String,Double>>, CarTrackModel> {

    private Map<String, Map<String,Double>> map = new HashMap();

    @Override
    public void flatMap1(CarTrackModel carTrackModel, Collector<CarTrackModel> collector) throws Exception {
        if (map != null && !map.isEmpty()) {
            String rid = carTrackModel.getRoadnet().getRid();
            String crossId = carTrackModel.getRoadnet().getCrossId();
            String key =  rid;
            if (!map.containsKey(key)) {
                return;
            }
            Double freeSpeed = map.get(key).get("freeSpeed");
            Double ridLevel = map.get(key).get("level")/*==null? RoadClassMap.CIYAO_DAO.getType():map.get(key).get("level")*/;
            Double ridLength = map.get(key).get("ridLength");
            Collection<Map<String,Double>> collection = map.values();
            double areaFreeSpeed =  collection.stream().mapToDouble(o->o.get("freeSpeed")).summaryStatistics().getAverage();

            carTrackModel.setAreaFreeSpeed(areaFreeSpeed);
            carTrackModel.getRoadnet().setFreeSpeed(freeSpeed);
            carTrackModel.getRoadnet().setRidLevel(ridLevel.intValue());
            carTrackModel.getRoadnet().setRidLength(ridLength);
            collector.collect(carTrackModel);
        }

    }

    @Override
    public void flatMap2( Map<String, Map<String,Double>> hashMap, Collector<CarTrackModel> collector) throws Exception {
        this.map = hashMap;
    }
}
