package com.wanji.indicators.task.area.service.func;

import com.wanji.indicators.constant.VehicleTypeEnum;
import com.wanji.indicators.task.area.service.model.ParticipantAnalysisOutputModel;
import com.wanji.indicators.task.area.service.model.ParticipantAnalysisMidResultModel;
import lombok.extern.slf4j.Slf4j;
import org.apache.flink.streaming.api.functions.windowing.ProcessAllWindowFunction;
import org.apache.flink.streaming.api.functions.windowing.ProcessWindowFunction;
import org.apache.flink.streaming.api.windowing.windows.TimeWindow;
import org.apache.flink.util.Collector;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.BeanUtils;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.util.stream.StreamSupport;

/**
 * @author fengyi
 * @date 2023/4/6
 * @description
 */
@Slf4j
public class RidOutProcessWindow extends ProcessWindowFunction<ParticipantAnalysisMidResultModel, ParticipantAnalysisOutputModel,String, TimeWindow> {

    @Override
    public void process(String key, Context context, Iterable<ParticipantAnalysisMidResultModel> elements, Collector<ParticipantAnalysisOutputModel> out) throws Exception {

        List<ParticipantAnalysisMidResultModel> list = StreamSupport.stream(elements.spliterator(), false).collect(Collectors.toList());
        Map<Integer,List<ParticipantAnalysisMidResultModel>> group =  list.stream().collect(Collectors.groupingBy(o->o.getCategory()));
        Integer[] categorys = new Integer[]{1,2,3};

        Map<Integer,ParticipantAnalysisOutputModel> outMap = new HashMap<>();

        for (Map.Entry<Integer,List<ParticipantAnalysisMidResultModel>> entry : group.entrySet()) {
            Integer category = entry.getKey();
            List<ParticipantAnalysisMidResultModel> value = entry.getValue();
            ParticipantAnalysisMidResultModel midModel  = value.get(0) ;

            ParticipantAnalysisOutputModel resultModel = new ParticipantAnalysisOutputModel();
            BeanUtils.copyProperties(midModel,resultModel);

            resultModel.setNumber(midModel.getCount());
            resultModel.setSpeed(midModel.getSpeed());

            outMap.put(category,resultModel);

        }
        ParticipantAnalysisOutputModel tmp = null;
        for (Map.Entry<Integer,ParticipantAnalysisOutputModel> entry : outMap.entrySet()) {
            tmp = entry.getValue();
            log.info("行人、非机动车对机动车速度影响结果："+tmp.toString());
            out.collect(entry.getValue());
        }
        //无数据的数量置为0
        for (Integer category : categorys) {
            if (!outMap.containsKey(category)) {
                ParticipantAnalysisOutputModel bean = new ParticipantAnalysisOutputModel();
                BeanUtils.copyProperties(tmp,bean);
                bean.setNumber(0L);
                bean.setSpeed(0d);
                bean.setCategory(category);
                log.info("行人、非机动车对机动车速度影响结果："+bean.toString());
                out.collect(bean);
            }
        }


    }
}
