package com.wanji.indicators.task.lightstatus;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.wanji.indicators.model.CarTrackModel;
import com.wanji.indicators.model.CrossFrameModel;
import com.wanji.indicators.model.CrossRidTurnLampStatusModel;
import com.wanji.indicators.model.event.confilct.EventCross;
import org.apache.flink.api.common.functions.FlatMapFunction;
import org.apache.flink.util.Collector;
import org.springframework.beans.factory.annotation.Value;

import java.util.*;

public class CrossLightStatusFlatMap implements FlatMapFunction<String, List<CrossRidTurnLampStatusModel>> {
    @Override
    public void flatMap(String value, Collector<List<CrossRidTurnLampStatusModel>> out) throws Exception {
        List<CrossRidTurnLampStatusModel> list = new ArrayList<>();

        JSONArray jsonArray = JSON.parseArray(value);
        int size = jsonArray.size();

        for (int i = 0; i < size; i++) {
            JSONObject jsonObject = jsonArray.getJSONObject(i);

            String crossId = jsonObject.getString("crossId");
            Integer cycleCountDown = jsonObject.getInteger("cycleCountDown");
            Integer cyclePhaseCountDown = jsonObject.getInteger("cyclePhaseCountDown");
            Integer cycleLen = jsonObject.getInteger("cycleLen");

            JSONObject jsonObject1 = jsonObject.getJSONObject("dirLampGroupMap");
            //遍历8方位方向
            for (int j = 1; j <= 8; j++) {
                JSONObject jsonObject2 = jsonObject1.getJSONObject(String.valueOf(i));

                if (jsonObject2 != null) {
                    Set<String> keys = jsonObject2.keySet();
                    for (String key : keys) {
                        String status = jsonObject2.getString(key);
                        CrossRidTurnLampStatusModel statusModel = new CrossRidTurnLampStatusModel();
                        statusModel.setCrossId(crossId);
                        statusModel.setDir(i);
                        statusModel.setCycleCountDown(cycleCountDown);
                        statusModel.setCycleLen(cycleLen);
                        statusModel.setCyclePhaseCountDown(cyclePhaseCountDown);
                        statusModel.setLampState(status);
                        statusModel.setTurn(key);
                        list.add(statusModel);
                    }
                }
            }

        }
        out.collect(list);
    }

}
